/*
btgetprv.c Version 0.1.0  Btree get previous
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/


#include <bthash.h>

int btgetprv(bthdr,ofst,key,buf)
btreefmt *bthdr;
off_t ofst;
unsigned char *key;
unsigned char *buf;
   {
   int rslt;
   unsigned char *p,*q,*r;
   unsigned char *prvkey;
   bthdr->reason = 0;
   prvkey = (unsigned char *) malloc(bthdr->keylen + 16);
   if (prvkey == NULL)
      {
      fprintf(stderr,"btgetprv: out of memory "
	 "allocating prvkey\n");
      return(BTREE_ERR + 901);
      } /* out of mem */
   p = (unsigned char *) prvkey;
   q = (unsigned char *) prvkey + bthdr->keylen;
   r = key;
   while (p < q) *p++ = *r++;
   *p = '\0';
   /* bypass deleted records */
   while (1)
      {
      p = prvkey + bthdr->keylen - 1;
      q = prvkey;
      while (p >= q)
         {
         (*p)--;
         if ((*p == 255)) p--;
         else break;
         } /* right to left */
      rslt = btgetp(bthdr,ROOT,prvkey,buf);
      p = (unsigned char *) bthdr->rcd;
      if (rslt == NOTFOUND)
         {
         if (*(p + bthdr->dletofst) == DELETED)
	    {
            p = (unsigned char *) bthdr->rcd
	       + bthdr->keyofst;
            q = (unsigned char *) p + bthdr->keylen;
            r = (unsigned char *) prvkey;
	    while (p < q) *r++ = *p++;
	    continue;
	    } /* bypass deleted index node */
         if (bthdr->reason != BTBOF)
            rslt = FOUND;
	 break;
         } /* if not found */
      else if (rslt == FRSTPAPA)
         {
         bthdr->reason = BTBOF;
         rslt = NOTFOUND;
	 break;
         } /* if FRSTPAPA */
      if (*(p + bthdr->dletofst) != DELETED) break;
      } /* search loop */
   free(prvkey);
   return(rslt);
   } /* btgetprv */
