#!/usr/bin/make

# librnd.mak Version 0.1.0 Compile librnd.a
# Copyright (C) 2003  dondalah@ripco.com (Dondalah)
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to:
# 
# 	Free Software Foundation, Inc.
# 	59 Temple Place - Suite 330
# 	Boston, MA  02111-1307, USA.

OBJ=rnd.o \
	rndnum.o \
	rndpwr.o \
	rndinit.o

CC=gcc

CFLAGS=-c -I../include -fPIC -Wall

all:		$(OBJ) librnd.so.0.0

static:		cflg $(OBJ) librnd.a

cflg:
		rm -f librnd.so*
		set CFLAGS=-c -I../include -Wall

librnd.a:		$(OBJ)
	rm -f librnd.a
	ar r librnd.a $(OBJ)

librnd.so.0.0:		$(OBJ)
	$(CC) -shared -Wl,-soname,librnd.so.0 \
	-o librnd.so.0.0 $(OBJ) -lc
	/sbin/ldconfig -n .
	ln -sf librnd.so.0 librnd.so
	# define LD_LIBRARY_PATH for librnd.so

rnd.o:		rnd.s
		$(CC) $(CFLAGS) rnd.s

rndnum.o:	rndnum.s
		$(CC) $(CFLAGS) rndnum.s

rndpwr.o:	rndpwr.s
		$(CC) $(CFLAGS) rndpwr.s

rndinit.o:	rndinit.c
		$(CC) $(CFLAGS) rndinit.c

clean:
	rm -f $(OBJ) librnd.a librnd.so*
